<?php 
?>


<?php 
\defined('_JEXEC') or die;


use Joomla\CMS\Application\SiteApplication;
use Joomla\CMS\Categories\CategoryFactoryInterface;
use Joomla\CMS\Categories\CategoryInterface;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Component\Router\RouterView;
use Joomla\CMS\Component\Router\RouterViewConfiguration;
use Joomla\CMS\Component\Router\Rules\MenuRules;
use Joomla\CMS\Component\Router\Rules\NomenuRules;
use Joomla\CMS\Component\Router\Rules\StandardRules;
use Joomla\CMS\Menu\AbstractMenu;
use Joomla\Database\DatabaseInterface;
use Joomla\Database\ParameterType;

/**
 * Routing class from com_contact
 *
 * @since  3.3
 */
class CirculationRouter extends RouterView
{
	/**
	 * Flag to remove IDs
	 *
	 * @var    boolean
	 */
	protected $noIDs = false;

	/**
	 * The category factory
	 *
	 * @var CategoryFactoryInterface
	 *
	 * @since  4.0.0
	 */
	private $categoryFactory;

	/**
	 * The category cache
	 *
	 * @var  array
	 *
	 * @since  4.0.0
	 */
	private $categoryCache = [];

	/**
	 * The db
	 *
	 * @var DatabaseInterface
	 *
	 * @since  4.0.0
	 */
	private $db;

	/**
	 * Content Component router constructor
	 *
	 * @param   SiteApplication           $app              The application object
	 * @param   AbstractMenu              $menu             The menu object to work with
	 * @param   CategoryFactoryInterface  $categoryFactory  The category object
	 * @param   DatabaseInterface         $db               The database object
	 */
	//public function __construct(SiteApplication $app, AbstractMenu $menu, CategoryFactoryInterface $categoryFactory, DatabaseInterface $db)
	public function __construct($app=null,  $menu=null)
	{
		
		
		//$this->db              = $db;

		$params = ComponentHelper::getParams('com_circulation');
		$this->noIDs = (bool) $params->get('sef_ids');
		
	
		
				
		$borgs = new RouterViewConfiguration('gallery');
		$borgs->setKey('title');
		$this->registerView($borgs);
		
		
		parent::__construct($app, $menu);

		$this->attachRule(new MenuRules($this));
		$this->attachRule(new StandardRules($this));
		$this->attachRule(new NomenuRules($this));
	}

	
	
	public function getGallerySegment($title,  $query)
	{	
		//return array('format'=> 'json', 'title'=>$query['title']);

				return array('format'=> 'json', 'title'=>$title);

	}
	
	public function getGalleryTitle($segment, $query)
	{
		return (int) $segment;
	}


    public function parse(&$segments){
		return parent::parse($segments);
	}

    public function build(&$query) {
		return parent::build($query);
	}


	
	
}


function CirculationBuildRoute(&$query) {

	$app = Factory::getApplication();
	$router = new CirculationRouter($app, $app->getMenu());
	return $router->build($query);
}

function CirculationParseRoute($segments) {

	$app = Factory::getApplication();
	$router = new CirculationRouter($app, $app->getMenu());
	return $router->parse($segments);
}




